class HEFace {
  int index;
  ArrayList<HalfEdge> edges;
  HEFace() {
    edges = new ArrayList<HalfEdge>();
  }
  
  HEFace(int _index) {
    this.index = _index;
    edges = new ArrayList<HalfEdge>();
  }

  PVector getCenter() {
    PVector average = new PVector(0, 0, 0);
    for (int i=0; i< edges.size (); i++) {
      average.add(edges.get(i).vertex.getVector());
    }
    average.div(edges.size());
    return average;
  }

  ArrayList<HEFace> getLinkedFaces() {
    ArrayList<HEFace> faces = new ArrayList<HEFace>();
    for (int i=0; i<edges.size (); i++) {
      if (edges.get(i).oppositeEdge != null) {
        faces.add(edges.get(i).oppositeEdge.face);
      }
    }
    return faces;
  }

  int getEdgeCount() {
    return edges.size();
  }

  void addEdge(HalfEdge edge) {
    edges.add(edge);
  }

  HalfEdge getEdge(int i) {
    return edges.get(i);
  }
}

