class HalfEdge {
  HEVertex vertex;
  HalfEdge prevEdge;
  HalfEdge nextEdge;
  HalfEdge oppositeEdge;
  HEFace face;

  HalfEdge(HEVertex _vertex) {
    vertex = _vertex;
  }
  HalfEdge(HEVertex _vertex, HEFace _face) {
    vertex = _vertex;
    face = _face;
  }
  boolean isHalf() {
    if (oppositeEdge != null) {
      return false;
    } else {
      return true;
    }
  }
  PVector getCenter() {
    PVector average = new PVector(0, 0, 0);
    average.add(vertex.getVector());
    average.add(nextEdge.vertex.getVector());
    average.div(2.0);
    return average;
  }

  PVector getImplicitPosiiton(float u) {
    PVector vector = PVector.sub(nextEdge.vertex.getVector(),vertex.getVector());
    if (u < 0) {
      u = 1.0+u;
    }
    vector.mult(u);
    return PVector.add(vector,(vertex.getVector()));
  }

  void setNextEdge(HalfEdge edge) {
    nextEdge = edge;
  }

  void setPrevEdge(HalfEdge edge) {
    prevEdge = edge;
  }

  void setOppositeEdge(HalfEdge edge) {
    oppositeEdge = edge;
  }

  String toString() {
    return "("+str(vertex.index) + "," + str(nextEdge.vertex.index) +")";
  }
}

