public ArrayList<PVector> getEdgeOptimizePath(PVector _start, PVector _goal, ArrayList<HalfEdge> _edgeOnRoute) {
  ArrayList<PVector> path = new ArrayList<PVector>();
  path.add(_start);
  for (HalfEdge edge : _edgeOnRoute) {
    path.add(edge.getCenter());
  }
  path.add(_goal);
  return path;
}

public ArrayList<PVector> getFunnelOptimizePath(PVector _start, PVector _goal, ArrayList<HalfEdge> _edgeOnRoute,float funnelMargin) {
  ArrayList<PVector> funnelOptimalPath = new ArrayList<PVector>();
  funnelOptimalPath.add(_start);

  PVector leftVector, rightVector, tightPoint, tmpVector;
  tightPoint = funnelOptimalPath.get(0);
  tmpVector = new PVector(0, 0, 0);
  int leftCount = 0;
  int rightCount = 0;
  int tmpCount = 0;
  leftVector = _edgeOnRoute.get(leftCount).nextEdge.vertex.getVector();
  leftVector.sub(tightPoint);
  rightVector = _edgeOnRoute.get(rightCount).vertex.getVector();
  rightVector.sub(tightPoint);
  boolean addLeft = true;
  boolean leftOver = false, rightOver=false;
  while (leftCount < _edgeOnRoute.size () && rightCount < _edgeOnRoute.size()) {
    if (addLeft) {
      tmpCount = leftCount +1;
    } else {
      tmpCount = rightCount +1;
    }
    if (tmpCount == _edgeOnRoute.size()) {
      if (leftOver) {
        if (leftCount < _edgeOnRoute.size ()) {
          funnelOptimalPath.add(_edgeOnRoute.get(leftCount).getImplicitPosiiton(funnelMargin));
          leftOver = false;
          rightOver = false;
          tmpCount = leftCount+1;
          leftCount++;
          rightCount = leftCount;
          addLeft = false;
        } else {
          break;
        }
      } else if (rightOver) {
        if (rightCount < _edgeOnRoute.size()) {
          funnelOptimalPath.add(_edgeOnRoute.get(rightCount).getImplicitPosiiton(funnelMargin));
          leftOver = false;
          rightOver = false;
          
          tmpCount = rightCount+1;
          rightCount++;
          leftCount = rightCount;
          addLeft = true;
        } else {
          break;
        }
      } else {
        break;
      }
      
    }
    if (addLeft) {
      tmpVector = PVector.sub(_edgeOnRoute.get(tmpCount).nextEdge.vertex.getVector(), tightPoint);
    } else {
      tmpVector = PVector.sub(_edgeOnRoute.get(tmpCount).vertex.getVector(), tightPoint);
    }

    if (drawCheck.getState("Funnel")) {
      strokeWeight(1);
      if (addLeft) {
        stroke(128, 255, 0, 100);
      } else {
        stroke(128, 128, 255, 100);
      }
      line(tightPoint.x, tightPoint.y, tightPoint.z, tmpVector.x + tightPoint.x, tmpVector.y + tightPoint.y, tmpVector.z + tightPoint.z);
    }

    leftVector = PVector.sub(_edgeOnRoute.get(leftCount).nextEdge.vertex.getVector(), tightPoint);
    if (leftVector.mag()<0.001) {
      leftCount ++;
      continue;
    }
    rightVector = PVector.sub(_edgeOnRoute.get(rightCount).vertex.getVector(), tightPoint);
    if (rightVector.mag() < 0.001) {
      rightCount ++;
      continue;
    }

    float angle = PVector.angleBetween(leftVector, rightVector);
    float angleLeft = PVector.angleBetween(leftVector, tmpVector);
    float angleRight = PVector.angleBetween(rightVector, tmpVector);

    if (addLeft) {
      if (getCrossY(rightVector, tmpVector) == -1 && getCrossY(leftVector, tmpVector) == -1) {
        //left over rihgt
        tightPoint = _edgeOnRoute.get(rightCount).getImplicitPosiiton(funnelMargin);
        funnelOptimalPath.add(tightPoint);
        leftCount = rightCount;
        rightCount ++;
        addLeft = false;
        leftOver = false;
        rightOver = false;
        log += "LR" + getCrossY(leftVector, tmpVector) + "," + getCrossY(rightVector, tmpVector) + "/";
      } else if (getCrossY(rightVector, tmpVector) == 1 && getCrossY(leftVector, tmpVector) == 1) {
        //left over left
        addLeft = false;
        leftOver = true;
        log += "LL" + getCrossY(leftVector, tmpVector) + "," + getCrossY(rightVector, tmpVector) + "/";
        if (rightOver) {
          tightPoint = _edgeOnRoute.get(rightCount).getImplicitPosiiton(funnelMargin);
          //tightPoint = edgeOnRoute.get(rightCount).getCenter();
          funnelOptimalPath.add(tightPoint);
          leftCount = rightCount;
          rightCount ++;
          addLeft = false;
          leftOver = false;
          rightOver = false;
        }
      } else {
        leftCount = tmpCount;
        if (rightOver) {
          addLeft = true;
        } else {
          addLeft = !addLeft;
        }
        log += "L_" + getCrossY(leftVector, tmpVector) + "," + getCrossY(rightVector, tmpVector) + "/";
      }
    } else {
      if (getCrossY(rightVector, tmpVector) == -1 && getCrossY(leftVector, tmpVector) == -1) {
        //right over right
        addLeft = true;
        rightOver = true;
        log += "RR" + getCrossY(leftVector, tmpVector) + "," + getCrossY(rightVector, tmpVector) + "/";
        if (leftOver) {
          tightPoint = _edgeOnRoute.get(leftCount).getImplicitPosiiton(funnelMargin);
          //tightPoint = edgeOnRoute.get(leftCount).getCenter();
          funnelOptimalPath.add(tightPoint);
          rightCount = leftCount;
          leftCount++;
          addLeft = true;
          leftOver = false;
          rightOver = false;
        }
      } else if (getCrossY(rightVector, tmpVector) == 1 && getCrossY(leftVector, tmpVector) == 1) {
        //right over left
        tightPoint = _edgeOnRoute.get(leftCount).getImplicitPosiiton(funnelMargin);
        funnelOptimalPath.add(tightPoint);
        rightCount = leftCount;
        leftCount++;
        addLeft = true;
        leftOver = false;
        rightOver = false;
        log += "RL" + getCrossY(leftVector, tmpVector) + "," + getCrossY(rightVector, tmpVector) + "/";
      } else {
        rightCount = tmpCount;
        if (leftOver) {
          addLeft = false;
        } else {
          addLeft = !addLeft;
        }
        log += "R_" + getCrossY(leftVector, tmpVector) + "," + getCrossY(rightVector, tmpVector) + "/";
      }
    }
  }
  //  if (leftOver) {
  //    funnelOptimalPath.add(_edgeOnRoute.get(leftCount).nextEdge.vertex.getVector());
  //    log += "lastLeftOver";
  //  } else if (rightOver) {
  //    funnelOptimalPath.add(_edgeOnRoute.get(rightCount).vertex.getVector());
  //    log += "lastRightOver";
  //  }
  //cap start point
  funnelOptimalPath.add(_goal);
  log += "\n";
  return funnelOptimalPath;
}

int getCrossY(PVector from, PVector to) {
  PVector v = from.cross(to);
  int res = 0;
  if (v.y > 0) {
    res = 1;
  } else if (v.y < 0) {
    res = -1;
  }
  return res;
}

